Index: config.sh
===================================================================
--- config.sh	(revision 11581)
+++ config.sh	(working copy)
@@ -697,13 +697,18 @@
 		grep CS_VERSION globals.h | cut -d\" -f2
 		break
 	;;
+	'--aio-version')
+		grep CS_AIO_VERSION globals.h | cut -d\" -f2
+		break
+	;;
 	'-r'|'--oscam-revision')
+		aioversion=$(grep CS_AIO_VERSION globals.h | cut -d\" -f2)
 		revision=`(svnversion -n . 2>/dev/null || printf 0) | sed 's/.*://; s/[^0-9]*$//; s/^$/0/'`
 		if [ "$revision" = "0" ]
 		then
 			which git > /dev/null 2>&1 && revision=`git log -10 --pretty=%B | grep git-svn-id | head -n 1 | sed -n -e 's/^.*trunk@\([0-9]*\) .*$/\1/p'`
 		fi
-		echo $revision
+		echo "$revision-CX-AIO-$aioversion"
 		break
 	;;
 	'-O'|'--detect-osx-sdk-version')
Index: globals.h
===================================================================
--- globals.h	(revision 11581)
+++ globals.h	(working copy)
@@ -361,6 +361,9 @@
  *			constants
  * =========================== */
 #define CS_VERSION				"1.20_svn"
+#ifdef CS_CACHEEX
+#define CS_AIO_VERSION			"9.2.4"
+#endif
 #ifndef CS_SVN_VERSION
 # define CS_SVN_VERSION			"test"
 #endif
@@ -418,9 +421,10 @@
 #define D_CLIENTECM				0x0400	// Debug Client ECMs
 #define D_CSP					0x0800	// Debug CSP
 #define D_CWC					0x1000	// Debug CWC
+#define D_CW_CACHE				0x2000	// Debug CW Cache
 #define D_ALL_DUMP				0xFFFF	// dumps all
 
-#define MAX_DEBUG_LEVELS		13
+#define MAX_DEBUG_LEVELS		14
 
 /////// phoenix readers which need baudrate setting and timings need to be guarded by OSCam: BEFORE R_MOUSE
 #define R_DB2COM1				0x1		// Reader Dbox2 @ com1
@@ -730,6 +734,9 @@
 typedef struct s_sidtab
 {
 	char			label[64];
+	uint8_t			disablecrccws_only_for_exception;
+	uint8_t			no_wait_time;
+	uint8_t			lg_only_exception;
 	uint16_t		num_caid;
 	uint16_t		num_provid;
 	uint16_t		num_srvid;
@@ -851,6 +858,7 @@
 	uint16_t		cache_srvid;
 	uint32_t		cache_prid;
 	int8_t			cache_direction;				// 0 = push / 1 = got
+	int32_t			cache_count_lg;
 } S_CACHEEX_STAT_ENTRY;
 
 typedef struct s_entitlement						// contains entitlement Info
@@ -1071,6 +1079,8 @@
 	uint16_t		cacheex_mode1_delay;			// cacheex mode 1 delay
 	uint8_t			cacheex_hitcache;				// =1 if wait_time due hitcache
 	void			*cw_cache;						// pointer to cw stored in cache
+	int32_t			ecm_time;						// ecm-time in ms
+	uint8_t			localgenerated;					// flag for local generated CW
 #endif
 	uint32_t		cw_count;
 	uint8_t			from_csp;						// =1 if er from csp cache
@@ -1247,7 +1257,10 @@
 	int32_t			cwcacheexerrcw;					// same Hex, different CW
 	int16_t			cwcacheexping;					// peer ping in ms, only used by csp
 	int32_t			cwc_info;						// count of in/out comming cacheex ecms with CWCinfo
+	int32_t			cwcacheexgotlg;					// count got localgenerated-flagged CWs
+	int32_t			cwcacheexpushlg;				// count pushed localgenerated-flagged CWs
 	uint8_t			cacheex_needfilter;				// flag for cachex mode 3 used with camd35
+	uint8_t			cacheex_aio_checked;			// flag for cachex aio detection done
 #endif
 #ifdef CS_ANTICASC
 	struct s_zap_list client_zap_list[15];			// 15 last zappings from client used for ACoSC
@@ -1451,7 +1464,17 @@
 	uint8_t			allow_reforward;
 	uint8_t			drop_csp;
 	uint8_t			allow_filter;
+	uint8_t			allow_maxhop;
 	uint8_t			block_fakecws;
+	uint8_t			cw_check_for_push;
+	uint8_t			localgenerated_only;
+	CAIDTAB			localgenerated_only_caidtab;
+	uint8_t			localgenerated_only_in;
+	CAIDTAB			localgenerated_only_in_caidtab;
+	uint8_t			lg_only_in_aio_only;
+	int32_t			feature_bitfield;
+	CAIDVALUETAB	cacheex_nopushafter_tab;
+	char			aio_version[12];
 } CECSP;
 
 struct s_emmlen_range
@@ -1900,6 +1923,8 @@
 	int32_t			cwcacheexerr;					// cw=00 or chksum wrong
 	int32_t			cwcacheexerrcw;					// Same Hex, different CW
 	int32_t			cwc_info;						// count of in/out comming cacheex ecms with CWCinfo
+	int32_t			cwcacheexgotlg;					// count got localgenerated-flagged CWs
+	int32_t			cwcacheexpushlg;				// count pushed localgenerated-flagged CWs
 #endif
 	struct s_auth	*next;
 };
@@ -2322,6 +2347,14 @@
 	int8_t			block_same_name;				// 0=allow all, 1=block client requests to reader with same name (default=1)
 
 #ifdef CS_CACHEEX
+	uint32_t		cw_cache_size;
+	uint32_t		cw_cache_memory;
+	CWCHECKTAB		cw_cache_settings;
+
+	uint32_t		ecm_cache_size;
+	uint32_t		ecm_cache_memory;
+	int32_t			ecm_cache_droptime;
+
 	uint8_t			wait_until_ctimeout;
 	CWCHECKTAB		cacheex_cwcheck_tab;
 	IN_ADDR_T		csp_srvip;
@@ -2328,9 +2361,21 @@
 	int32_t			csp_port;
 	CECSPVALUETAB	cacheex_wait_timetab;
 	CAIDVALUETAB	cacheex_mode1_delay_tab;
+	CAIDVALUETAB	cacheex_nopushafter_tab;
+	uint8_t			waittime_block_start;
+	uint16_t		waittime_block_time;
 	CECSP			csp;							// CSP Settings
 	uint8_t			cacheex_enable_stats;			// enable stats
 	struct s_cacheex_matcher *cacheex_matcher;
+	uint8_t			cacheex_dropdiffs;
+	uint8_t			cacheex_localgenerated_only;
+	CAIDTAB			cacheex_localgenerated_only_caidtab;
+	uint8_t			cacheex_localgenerated_only_in;
+	CAIDTAB			cacheex_localgenerated_only_in_caidtab;
+	uint8_t			cacheex_lg_only_in_aio_only;
+	CECSPVALUETAB	cacheex_filter_caidtab;
+	CECSPVALUETAB	cacheex_filter_caidtab_aio;
+	uint64_t		cacheex_push_lg_groups;
 #endif
 
 #ifdef CW_CYCLE_CHECK
Index: module-cacheex.c
===================================================================
--- module-cacheex.c	(revision 11581)
+++ module-cacheex.c	(working copy)
@@ -45,6 +45,7 @@
 	struct timeb	max_hitcache_time;
 	uint64_t		grp;
 	uint64_t		grp_last_max_hitcache_time;
+	int32_t			waittime_block;
 	node			ht_node;
 	node			ll_node;
 } CACHE_HIT;
@@ -101,6 +102,8 @@
 			gone <= (cfg.max_hitcache_time*1000)
 			&&
 			(!grp || !result->grp || (grp & result->grp))
+			&&
+			result->waittime_block <= cfg.waittime_block_start
 		)
 		{
 			SAFE_RWLOCK_UNLOCK(&hitcache_lock);
@@ -141,6 +144,7 @@
 			result->key.prid = er->prid;
 			result->key.srvid = er->srvid;
 			cs_ftime(&result->max_hitcache_time);
+			result->waittime_block = 0;
 			add_hash_table(&ht_hitcache, &result->ht_node, &ll_hitcache, &result->ll_node, result, &result->key, sizeof(HIT_KEY));
 		}
 	}
@@ -210,7 +214,7 @@
 		gone = comp_timeb(&now, &cachehit->time);
 		gone_max_hitcache_time = comp_timeb(&now, &cachehit->max_hitcache_time);
 
-		if(force || gone>timeout)
+		if(force || gone>timeout || (cachehit->waittime_block > (cfg.waittime_block_time / 3 + 1)))
 		{
 			remove_elem_list(&ll_hitcache, &cachehit->ll_node);
 			remove_elem_hash_table(&ht_hitcache, &cachehit->ht_node);
@@ -221,6 +225,12 @@
 			cachehit->grp_last_max_hitcache_time = 0;
 			cs_ftime(&cachehit->max_hitcache_time);
 		}
+
+		if(cfg.waittime_block_start && (cachehit && cachehit->waittime_block >= cfg.waittime_block_start))
+		{
+			cachehit->waittime_block++;
+		}
+
 		i = i_next;
 	}
 	SAFE_RWLOCK_UNLOCK(&hitcache_lock);
@@ -394,6 +404,8 @@
 	account->cwcacheexgot = 0;
 	account->cwcacheexpush = 0;
 	account->cwcacheexhit = 0;
+	account->cwcacheexgotlg = 0;
+	account->cwcacheexpushlg = 0;
 }
 
 void cacheex_clear_client_stats(struct s_client *client)
@@ -401,9 +413,11 @@
 	client->cwcacheexgot = 0;
 	client->cwcacheexpush = 0;
 	client->cwcacheexhit = 0;
+	client->cwcacheexgotlg = 0;
+	client->cwcacheexpushlg = 0;
 }
 
-int32_t cacheex_add_stats(struct s_client *cl, uint16_t caid, uint16_t srvid, uint32_t prid, uint8_t direction)
+int32_t cacheex_add_stats(struct s_client *cl, uint16_t caid, uint16_t srvid, uint32_t prid, uint8_t direction, uint8_t localgenerated)
 {
 	if(!cfg.cacheex_enable_stats)
 		{ return -1; }
@@ -426,6 +440,8 @@
 		{
 			// we already have this entry - just add count and time
 			cacheex_stats_entry->cache_count++;
+			if(localgenerated)
+				cacheex_stats_entry->cache_count_lg++;
 			cacheex_stats_entry->cache_last = now;
 			return cacheex_stats_entry->cache_count;
 		}
@@ -438,6 +454,8 @@
 		cacheex_stats_entry->cache_srvid = srvid;
 		cacheex_stats_entry->cache_prid = prid;
 		cacheex_stats_entry->cache_count = 1;
+		if(localgenerated)
+				cacheex_stats_entry->cache_count_lg = 1;
 		cacheex_stats_entry->cache_last = now;
 		cacheex_stats_entry->cache_direction = direction;
 		ll_iter_insert(&itr, cacheex_stats_entry);
@@ -472,6 +490,32 @@
 	return 0;
 }
 
+static uint8_t chk_cwcheck(ECM_REQUEST *er, uint8_t cw_check_for_push)
+{
+	if(!cw_check_for_push)
+		return 1;
+	
+	CWCHECK check_cw;
+	check_cw = get_cwcheck(er);
+
+	if(check_cw.mode && check_cw.counter > 1)
+	{
+		if(er->cw_count >= check_cw.counter)
+		{
+			return 1;
+		}
+		else
+		{
+			cs_log_dbg(D_CACHEEX, "push denied - cacheex_check_cw.counter: %u > er->cw_count: %u", check_cw.counter, er->cw_count);
+			return 0;
+		}
+	}
+	else
+	{
+		return 1;
+	}
+}
+
 /**
  * cacheex modes:
  *
@@ -514,7 +558,7 @@
 			else if(cl->typ == 'c' && !cl->dup && cl->account && cl->account->cacheex.mode == 2) // send cache over user
 			{
 				if(get_module(cl)->c_cache_push // cache-push able
-						&& (!er->grp || (cl->grp & er->grp)) // Group-check
+						&& (!er->grp || (cl->grp & er->grp) || (er->localgenerated && ((cl->grp & cfg.cacheex_push_lg_groups) && strcmp(username(cl), username(er->cacheex_src))))) // Group-check
 						/**** OUTGOING FILTER CHECK ***/
 						&& (!er->selected_reader || !cacheex_reader(er->selected_reader) || !cfg.block_same_name || strcmp(username(cl), er->selected_reader->label)) // check reader mode-1 loopback by same name
 						&& (!er->selected_reader || !cacheex_reader(er->selected_reader) || !cfg.block_same_ip || (check_client(er->selected_reader->client) && !IP_EQUAL(cl->ip, er->selected_reader->client->ip))) // check reader mode-1 loopback by same ip
@@ -522,7 +566,10 @@
 						&& chk_ctab(er->caid, &cl->ctab)                                        // Caid-check
 						&& (!checkECMD5(er) || chk_ident_filter(er->caid, er->prid, &cl->ftab)) // Ident-check (not for csp: prid=0 always!)
 						&& chk_srvid(cl, er)                                                    // Service-check
-						&& chk_csp_ctab(er, &cl->account->cacheex.filter_caidtab))              // cacheex_ecm_filter
+						&& chk_csp_ctab(er, &cl->account->cacheex.filter_caidtab)               // cacheex_ecm_filter
+						&& (er->localgenerated || (chk_srvid_localgenerated_only_exception(er)) || !(cl->account->cacheex.localgenerated_only || chk_ctab_ex(er->caid, &cl->account->cacheex.localgenerated_only_caidtab) || chk_ctab_ex(er->caid, &cfg.cacheex_localgenerated_only_caidtab))) // only localgenerated flagged
+						&& (chk_cwcheck(er, cl->account->cacheex.cw_check_for_push))			// check cw_check-counter if enabled
+						&& chk_nopushafter(er->caid, &cl->account->cacheex.cacheex_nopushafter_tab, er->ecm_time)) // no push after check
 				{
 					cacheex_cache_push_to_client(cl, er);
 				}
@@ -536,12 +583,12 @@
 	cs_readlock(__func__, &clientlist_lock);
 	struct s_reader *rdr;
 	for(rdr = first_active_reader; rdr; rdr = rdr->next)
-	{
+	{	
 		cl = rdr->client;
 		if(check_client(cl) && er->cacheex_src != cl && rdr->cacheex.mode == 3) // send cache over reader
 		{
 			if(rdr->ph.c_cache_push // cache-push able
-					&& (!er->grp || (rdr->grp & er->grp)) // Group-check
+					&& (!er->grp || (rdr->grp & er->grp) || (er->localgenerated && ((rdr->grp & cfg.cacheex_push_lg_groups) && strcmp(username(cl), username(er->cacheex_src))))) // Group-check
 					/**** OUTGOING FILTER CHECK ***/
 					&& (!er->selected_reader || !cacheex_reader(er->selected_reader) || !cfg.block_same_name || strcmp(username(cl), er->selected_reader->label)) // check reader mode-1 loopback by same name
 					&& (!er->selected_reader || !cacheex_reader(er->selected_reader) || !cfg.block_same_ip || (check_client(er->selected_reader->client) && !IP_EQUAL(cl->ip, er->selected_reader->client->ip))) // check reader mode-1 loopback by same ip
@@ -549,7 +596,10 @@
 					&& chk_ctab(er->caid, &rdr->ctab)                                        // Caid-check
 					&& (!checkECMD5(er) || chk_ident_filter(er->caid, er->prid, &rdr->ftab)) // Ident-check (not for csp: prid=0 always!)
 					&& chk_srvid(cl, er)                                                     // Service-check
-					&& chk_csp_ctab(er, &rdr->cacheex.filter_caidtab))                       // cacheex_ecm_filter
+					&& chk_csp_ctab(er, &rdr->cacheex.filter_caidtab)                        // cacheex_ecm_filter
+					&& (er->localgenerated || !(chk_srvid_localgenerated_only_exception(er) || rdr->cacheex.localgenerated_only || chk_ctab_ex(er->caid, &rdr->cacheex.localgenerated_only_caidtab) || chk_ctab_ex(er->caid, &cfg.cacheex_localgenerated_only_caidtab))) // only localgenerated flagged 
+					&& (chk_cwcheck(er, rdr->cacheex.cw_check_for_push))                     // check cw_check-counter if enabled
+					&& chk_nopushafter(er->caid, &rdr->cacheex.cacheex_nopushafter_tab, er->ecm_time)) // no push after check
 			{
 				cacheex_cache_push_to_client(cl, er);
 			}
@@ -641,6 +691,27 @@
 			reason, buf_ecm, er->ecm[0], (checkECMD5(er)?"NO":"YES"), er->from_csp ? "csp" : username((er->cacheex_src?er->cacheex_src:er->client)), ll_count(er->csp_lastnodes), er->csp_lastnodes ? cacheex_node_id(remotenodeid): 0);
 }
 
+// check if sky_ger 64 bit CW has valid checksum bytes and therefore is probably invalid
+uint8_t check_nds_cwex(ECM_REQUEST *er)
+{
+	uint8_t k, csum;
+	uint8_t hit = 0;
+	uint8_t oe = checkCWpart(er->cw, 0) ? 0 : 8;
+	for(k = 0; k < 8; k += 4)
+	{
+		csum = ((er->cw[k + oe] + er->cw[k + oe + 1] + er->cw[k + oe + 2]) & 0xff);
+		if(er->cw[k + oe + 3] == csum)
+		{
+			hit++;
+		}
+	}
+	if(hit > 1)
+	{
+		return 1;
+	}
+	return 0;
+}
+
 static int32_t cacheex_add_to_cache_int(struct s_client *cl, ECM_REQUEST *er, int8_t csp)
 {
 	if(er->rc >= E_NOTFOUND) { return 0; }
@@ -693,6 +764,33 @@
 		}
 	}
 
+	if(caid_is_videoguard(er->caid))
+	{
+		if(cl->typ == 'p' && chk_if_ignore_checksum(er, &cl->reader->disablecrccws_only_for) && !chk_srvid_disablecrccws_only_for_exception(er))
+		{
+			if(check_nds_cwex(er))
+			{
+				if(cl->reader->dropbadcws)
+				{
+					cs_log_dbg(D_CACHEEX, "Probably got pushed bad CW to cacheex reader: %s, caid %04X, srvid %04X - dropping CW", cl->reader->label, er->caid, er->srvid);
+					return 0;
+				}
+				else
+				{
+					cs_log_dbg(D_CACHEEX, "Probably got pushed bad CW to cacheex reader: %s, caid %04X, srvid %04X", cl->reader->label, er->caid, er->srvid);
+				}
+			}
+		}
+
+		if(cl->typ == 'c' && chk_if_ignore_checksum(er, &cl->account->disablecrccacheex_only_for) && !chk_srvid_disablecrccws_only_for_exception(er))
+		{
+			if(check_nds_cwex(er))
+			{
+				cs_log_dbg(D_CACHEEX, "Probably got bad CW from cacheex user: %s, caid %04X, srvid %04X", username(cl), er->caid, er->srvid);
+			}
+		}
+	}
+
 	// Skip check for BISS1 - cw could be indeed zero
 	// Skip check for BISS2 - we use the extended cw, so the "simple" cw is always zero
 	if(chk_is_null_CW(er->cw) && !caid_is_biss(er->caid))
@@ -749,11 +847,20 @@
 		if(cl->account)
 			{ cl->account->cwcacheexgot++; }
 		first_client->cwcacheexgot++;
+
+		if(er->localgenerated)
+		{
+			cl->cwcacheexgotlg++;
+			if(cl->account)
+				cl->account->cwcacheexgotlg++;
+			first_client->cwcacheexgotlg++;
+		}
+
 	}
 
 	cacheex_add_hitcache(cl, er); // we have to call it before add_cache, because in chk_process we could remove it!
 	add_cache(er);
-	cacheex_add_stats(cl, er->caid, er->srvid, er->prid, 1);
+	cacheex_add_stats(cl, er->caid, er->srvid, er->prid, 1, er->localgenerated);
 
 	cs_writelock(__func__, &ecm_pushed_deleted_lock);
 	er->next = ecm_pushed_deleted;
@@ -1031,7 +1138,7 @@
 		if(reader->ph.c_cache_push_chk && !reader->ph.c_cache_push_chk(cl, er))
 			return;
 		res = reader->ph.c_cache_push(cl, er);
-		stats = cacheex_add_stats(cl, er->caid, er->srvid, er->prid, 0);
+		stats = cacheex_add_stats(cl, er->caid, er->srvid, er->prid, 0, er->localgenerated);
 	}
 	else
 	{
@@ -1044,6 +1151,14 @@
 	if(cl->account)
 		{ cl->account->cwcacheexpush++; }
 	first_client->cwcacheexpush++;
+
+	if(er->localgenerated)
+	{
+		cl->cwcacheexpushlg++;
+		if(cl->account)
+			cl->account->cwcacheexpushlg++;
+		first_client->cwcacheexpushlg++;
+	}
 }
 
 bool cacheex_check_queue_length(struct s_client *cl)
@@ -1093,6 +1208,29 @@
 		cs_log_dbg(D_LB, "{client %s, caid %04X, prid %06X, srvid %04X} cacheex timeout! ",
 					(check_client(er->client) ? er->client->account->usr : "-"), er->caid, er->prid, er->srvid);
 
+		CACHE_HIT *result;
+		HIT_KEY search;
+
+		memset(&search, 0, sizeof(HIT_KEY));
+		search.caid = er->caid;
+		search.prid = er->prid;
+		search.srvid = er->srvid;
+
+		SAFE_RWLOCK_WRLOCK(&hitcache_lock);
+
+		result = find_hash_table(&ht_hitcache, &search, sizeof(HIT_KEY), &cacheex_compare_hitkey);
+		if(result)
+		{
+			if(cfg.waittime_block_start && (result->waittime_block <= cfg.waittime_block_start))
+			{
+				result->waittime_block++;
+				cs_log_dbg(D_LB, "{client %s, caid %04X, prid %06X, srvid %04X} waittime_block count: %u ",
+					(check_client(er->client) ? er->client->account->usr : "-"), er->caid, er->prid, er->srvid, result->waittime_block);
+			}			
+		}
+
+		SAFE_RWLOCK_UNLOCK(&hitcache_lock);
+
 		// if check_cw mode=0, first try to get cw from cache without check counter!
 		CWCHECK check_cw = get_cwcheck(er);
 		if(!check_cw.mode)
Index: module-cacheex.h
===================================================================
--- module-cacheex.h	(revision 11581)
+++ module-cacheex.h	(working copy)
@@ -15,7 +15,7 @@
 void cacheex_add_to_cache(struct s_client *cl, ECM_REQUEST *er);
 void cacheex_add_to_cache_from_csp(struct s_client *cl, ECM_REQUEST *er);
 void cacheex_cache_push(ECM_REQUEST *er);
-int32_t cacheex_add_stats(struct s_client *cl, uint16_t caid, uint16_t srvid, uint32_t prid, uint8_t direction);
+int32_t cacheex_add_stats(struct s_client *cl, uint16_t caid, uint16_t srvid, uint32_t prid, uint8_t direction, uint8_t localgenerated);
 int8_t cacheex_maxhop(struct s_client *cl);
 
 #ifdef CS_CACHEEX
@@ -39,6 +39,7 @@
 void cacheex_update_hash(ECM_REQUEST *er);
 void cacheex_mode1_delay(ECM_REQUEST *er);
 void cacheex_timeout(ECM_REQUEST *er);
+#define CACHEEX_FEATURES 63
 #else
 static inline void cacheex_init(void) { }
 static inline void cacheex_clear_account_stats(struct s_auth *UNUSED(account)) { }
